'
' Listing 23.1: A WMI Script That Toggles a Service's State Between Started and Stopped
'
Option Explicit
Dim strComputer, strServiceName, intReturn
Dim objWMI, objServices, objService
'
' Get the WMI service
'
strComputer = "localhost"
Set objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & _
    strComputer & "\root\cimv2")
'
' Specify the service name
'
strServiceName = "Remote Registry"
'
' Get the service instance
'
Set objServices = objWMI.ExecQuery("SELECT * FROM Win32_Service " & _
                  "WHERE DisplayName = '" & strServiceName & "'")
For Each objService In objServices
    '
    ' Save the service name
    '
    strServiceName = objService.DisplayName
    '
    ' Is the service started?
    '
    If objService.Started Then
        '
        ' Can it be stopped?
        '
        If objService.AcceptStop Then
            '
            ' Attempt to stop the service
            '
            intReturn = objService.StopService
            '
            ' Check the return value
            '
            If intReturn <> 0 Then
                '
                ' Display the error message
                '
                WScript.Echo "ERROR: The " & strServiceName & " service " & _
                             "failed to stop. The return code is " & intReturn
            Else
                '
                ' Display the current state
                '
                WScript.Echo "The " & strServiceName & " service is now " & _
                             objService.State
            End If
        Else
            '
            ' Display the error message
            '
            WScript.Echo "ERROR: The " & strServiceName & " service " & _
                         "cannot be stopped."
        End If
    Else
        '
        ' Attempt to start the service
        '
        intReturn = objService.StartService
        '
        ' Check the return value
        '
        If intReturn <> 0 Then
            '
            ' Display the error message
            '
            WScript.Echo "ERROR: The " & strServiceName & " service " & _
                         "failed to start. The return code is " & intReturn
        Else
            '
            ' Display the current state
            '
            WScript.Echo "The " & strServiceName & " service is now " & _
                         objService.State
        End If
    End If
Next
'
' Release the objects
'
Set objWMI = Nothing
Set objServices = Nothing
Set objService = Nothing
